<?php
/**
 * Connected
 *
 * @license		GPL
 * @package		Connected
 * @link		https://gitlab.liris.cnrs.fr/mloiseau/mw_connected
 *
 **/
class ConnectedHooks {
	// Register any render callbacks with the parser
	public static function onParserFirstCallInit( Parser $parser ) {
		// Create a function hook associating the "example" magic word with renderExample()
		$parser->setFunctionHook( 'iflogged', [ self::class, 'ifConnectedRender' ] );
	}

	// Render the output of {{#ifloggedin:}} i.e. iflogged function.
	public static function ifConnectedRender( Parser $parser, $ifLoggedIn = '', $ifNot = '') {
		// The input parameters are wikitext with templates expanded.
		// The output should be wikitext too.
		global $wgUser;
		if($wgUser->isSafeToLoad()){
			if ( $wgUser->isLoggedIn() ) {
				$output = $ifLoggedIn;
			}
			else{
				$output = $ifNot;
			}
		}
		return [ $output, 'noparse' => false ];
	}

	//calcul des variables
	public static function wfConnectedAssignValue( Parser $parser, &$cache, $magicWordId, &$ret, $frame) {
		global $wgUser;
		$result = false;
		if($wgUser->isSafeToLoad()){
			switch($magicWordId){
				case 'connected' :
					if ( !$wgUser->isLoggedIn() ) {
						$ret = 0;
						$result = true;
					}
					else{
						$ret = 1;
						$result = true;
					}
					break;
				case 'u_name':
					if ( !$wgUser->isLoggedIn() ) {
						$ret = $wgUser->getName();
						$result = true;
					}
					else{
						$ret = $wgUser->getName();
						$result = true;
					}
					break;
			}
		}
		return $result;
	}

	//mettre à jour la liste de variables
	public static function connectedDeclareVarIds( &$customVariableIds ) {
		// $customVariableIds is where MediaWiki wants to store its list of custom
		// variable IDs. We oblige by adding ours:
		$customVariableIds[] = 'connected';
		$customVariableIds[] = 'u_name';
	}
}
